program day14
    implicit none
    integer, parameter :: max_chars = 300
    integer, parameter :: max_rows = 300
    character(200) :: fname
    character(max_chars) :: fline
    integer :: n_arguments
    integer :: istat
    character(len=max_chars) :: map(1:max_rows)
    character(len=1) :: cchar
    integer :: rows, cols, strlen
    integer :: i, i2, i3, tot_weight, tweight
    logical :: rest

    n_arguments = command_argument_count()
    if (n_arguments .eq. 1) then
        call get_command_argument(1, fname)
        print *, "File: ", trim(fname)
        print *
    else
        print *, "Wrong number of arguments: ", n_arguments
        stop
    end if
    open(10, file=fname)
    rows = 0
    do i=1,max_rows
        read(10, "(a)", iostat=istat) fline
        strlen = len_trim(fline)
        if ((strlen .eq. 0) .or. (is_iostat_end(istat))) then
            exit
        end if
        rows = rows + 1
        map(rows) = fline
    end do
    cols = len_trim(map(1))

    tot_weight = 0
    print *, "Starting position:"
    do i3=1,rows
        print *, trim(map(i3))
    end do
    print *
    do i=1,rows
        do i2=1,cols
            if (map(i)(i2:i2) .eq. 'O') then
                map(i)(i2:i2) = '.'
                rest = .false.
                if (i .gt. 1) then
                    do i3=i-1,1,-1
                        cchar = map(i3)(i2:i2)
                        if (cchar .ne. '.') then
                            map(i3+1)(i2:i2) = 'O'
                            tweight = rows - i3
                            rest = .true.
                            exit
                        end if
                    end do
                end if
                if (.not. rest) then
                    map(1)(i2:i2) = 'O'
                    tweight = rows
                end if
                tot_weight = tot_weight + tweight
            end if
        end do
    end do
    print *, "End position:"
    do i3=1,rows
        print *, trim(map(i3))
    end do
    print *
    print *, "Total weighting: ", tot_weight
end program day14

